﻿//

// CODE BY eubé ! 

// based on some spectrum analyser script (googled)

// work in progress ...

// ko[py]rate 2o11 

// thebeatniks.org/papers/xtra.php

//

// VERSION CONTAINING LIVE EDITOR

package {
	import fl.motion.easing.Quadratic;	
	
	import flash.display.Graphics;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundMixer;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;		
	import flash.display.Loader;
	import flash.events.MouseEvent;
	import flash.net.URLLoader;
	import flash.display.LoaderInfo;
import fl.controls.Label;
    import fl.controls.NumericStepper;
	/**
	 * @author Mike Creighton
	 */
	public class BasicAnalyzeredit extends Sprite {

		private const BAR_MAX_HEIGHT : int = 100; // The maximum height for each bar.
		private const NUM_SEGMENTS : int = 10; // Defines how many bars you'll have across.	
		
		private const BAR_WIDTH : int = 35; // The width of each bar.
		private const BAR_SPACING : int = 5; // The number of pixels between each bar.
		private const MARGIN : int = 16; // The amount of margin on the edges of the stage.
		// You don't want to touch this value since it's based on the number
		// of values within each stereo channel
		private const CHANNEL_LENGTH : int = 256;
		
		private const VALUES_PER_SEGMENT : int = Math.floor(CHANNEL_LENGTH / NUM_SEGMENTS);
		var num:NumericStepper;
		
		
			
			
		private var segmentTotals : Array;
		private var barsHolder : Sprite;
		private var bars : Array;
		var oldBarHeight : Array = new Array();
		var azert;

		public function BasicAnalyzeredit() {
			barsHolder = new Sprite();
			addChild(barsHolder);
			barsHolder.x = MARGIN;
			barsHolder.y = MARGIN * 2 + BAR_MAX_HEIGHT;
			
			
			
			segmentTotals = new Array(NUM_SEGMENTS);
			
			
			// Create a callback where we look at the audio spectrum
			LoadElements(); 
		}
		var vZone:mcItem;
		public function LoadElements() {
		
			
			vZone = new mcItem();
			addChild(vZone);
			vZone.name = "vZone";
			
			fLoadXML();
		
		}
		
		/////////////////////////////////
		// 
		// VARIABLES
		//
		/////////////////////////////////
		
		private var vLoader:Loader, vURLLoader:URLLoader, vXMLData:XML;
		private var vItemId:int, vItemTotal:int, vXMLItem:int;
		
		
		
		private var aList:Array = new Array();
		private var aElem:Array = new Array();
		private var aElemXML:Array = new Array(
			
			"xml/0.xml", 
			"xml/1.xml", 
			"xml/2.xml"
			
		);
		
		/////////////////////////////////
		// 
		// FONCTIONS
		//
		/////////////////////////////////
		
		function fLoadXML() {
			
			vURLLoader = new URLLoader();
			vURLLoader.addEventListener (Event.COMPLETE, fReadXML);
			vURLLoader.load (new URLRequest(aElemXML[vXMLItem]));
			vXMLItem++;
		
		}
		
		function fReadXML(e:Event) :void {
		
			vURLLoader.removeEventListener (Event.COMPLETE, fReadXML);
			vXMLData = new XML(e.target.data);
		
			var mc:mcItem = new mcItem();
			
			mc.x = vXMLData.xPos;
			mc.y = vXMLData.yPos;
			
			vZone.addChild(mc);
			vZone.setChildIndex(mc, vItemId);
			
			for each(var item:XML in vXMLData.item.*) aList.push(item);
		
			fLoadFile();
		}
		
		
		
		function fLoadFile() {
			
			vLoader = new Loader();
			vLoader.load(new URLRequest(aList[vItemTotal]));
			vLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, fAddItem);	
		}
		function changeOccurred(e:Event) {
			
			trace(String(e.target.value).substr(0, 1)+" - "+String(e.target.value).substr(2, 1));
			aElem[String(e.target.value).substr(0, 1)] = Number(String(e.target.value).substr(2, 1))-1;
			
		}
		function fAddItem(e:Event) {
			
			vItemTotal++;
			var mc:mcItem = new mcItem();
			mc.addChild(LoaderInfo(e.target).content);
			var aaa = vZone.getChildAt(vItemId);
			
			aaa.addChild(mc);
			aaa.setChildIndex(mc, 0);
			
			if (aList[vItemTotal] != null) fLoadFile();
			
			else{ 
			
				vItemId++;
				
				trace("loaded : "+vItemId+"/"+aElemXML.length+" | frames : "+(vItemTotal-1));
				
				if (aElemXML[vXMLItem] != null) {
					
					vItemTotal = 0;
					aList = new Array();
					fLoadXML();
			
				}else{
						
					for (var i : int = 0; i < vItemId; i++) {
						aElem[i] = i;
						num = new NumericStepper();
						num.stepSize = .1;
						num.minimum = i;
						num.maximum = i+(NUM_SEGMENTS/10);
						trace(i);
						trace(i+(NUM_SEGMENTS/10));
						num.width = 40;
						var bbb = vZone.getChildAt(i);
						num.value = (i+((i+1)/10));
						num.y = bbb.y;
						num.x = bbb.x+bbb.width-40;
						addChild(num);
						num.addEventListener(Event.CHANGE, changeOccurred);
				
					}
			
					trace("start");
					
			var snd : Sound = new Sound();
			var req : URLRequest = new URLRequest("son.mp3"); // Replace the MP3 name with your own MP3.
			snd.load(req);
			var channel : SoundChannel;
			channel = snd.play();
			channel.addEventListener(Event.SOUND_COMPLETE, onPlaybackComplete);
			
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		
					
				}
			}
		}
		
		private function onEnterFrame(event : Event) : void {
			
			var newBarHeight : Number = 0;
			var segmentCounter : Number = 0;
			var channelCounter : Number = 0;
			var valuesAverage : Number = 0;
			var diff : Number = 0;
			var i : int;
			var n : Number = 0;
			
			for (i = 0; i < segmentTotals.length; i++)  segmentTotals[i] = 0;
			
			
			var bytes : ByteArray = new ByteArray();
			// Take a picture of the audio data that's playing
			SoundMixer.computeSpectrum(bytes, true, 0);

			for (segmentCounter = 0; segmentCounter < NUM_SEGMENTS; segmentCounter++) {
				for (i = 0; i < VALUES_PER_SEGMENT; i++) {
					n = Math.abs(bytes.readFloat());
					segmentTotals[segmentCounter] += n;
					channelCounter++; 
				}
			}
			
			diff = CHANNEL_LENGTH - channelCounter;
			if(diff > 0) {
				for (i = 0; i < diff; i++) {
					bytes.readFloat();
					channelCounter++;
				}
			}
			
			channelCounter = 0;
			for (segmentCounter = 0; segmentCounter < NUM_SEGMENTS; segmentCounter++) {
				for (i = 0; i < VALUES_PER_SEGMENT; i++) {	
					n = Math.abs(bytes.readFloat());
					segmentTotals[segmentCounter] += n;
					channelCounter++; 
				}
			}
			
			var g : Graphics = graphics;
			g.clear();			
			
			
			// Go through all values in the ByteArray
			
			for (i = 0; i <segmentTotals.length; i++) {
				// Average the values we stuck in each segmentTotals index.
				valuesAverage = segmentTotals[i] / (VALUES_PER_SEGMENT * 2);
				valuesAverage = Quadratic.easeOut(valuesAverage, 0, 1, 1);
				if(valuesAverage > 1)
					valuesAverage = 1;
				// Derive the new height from that averaged value.
				newBarHeight = Math.round(valuesAverage * BAR_MAX_HEIGHT);
				if (newBarHeight > oldBarHeight[i]*1.5) azert = "pic";
				else azert = "poc";
				var zz = 0;
				var az = ((oldBarHeight[i]/newBarHeight)-1)*18;
				
				az = Math.round(az);
				
				if (az < 1 && az != "Infinity") az = 0 ;
				if (zz > 0) zz = 1;
				if (az > 0) {
					
					var bbb = new mcItem();
					for (var j = 0; j < aElem.length; j++) if (aElem[j] == i) {
						
						bbb = vZone.getChildAt(j);
						if (newBarHeight > 30) bbb.setChildIndex(bbb.getChildAt(0), bbb.numChildren-1); 
							
						else bbb.setChildIndex(bbb.getChildAt(bbb.numChildren-1), 0); 
						
					}
		
				}
				
				oldBarHeight[i] = newBarHeight;
				newBarHeight+=10;
				
				// Draw a basic segment bar.
				g.beginFill(0xFFFFFF);
				g.drawRect(MARGIN + i * (BAR_WIDTH + BAR_SPACING)+100, MARGIN + (BAR_MAX_HEIGHT - newBarHeight), BAR_WIDTH, newBarHeight);
				g.endFill();
				
				
			}
		}

		private function onPlaybackComplete(event : Event) : void {
			removeEventListener(Event.ENTER_FRAME, onEnterFrame);
		}
	}
}

